package org.itscool.weber.tag;

import javax.servlet.jsp.JspException;

import org.itscool.commons.util.JspTagUtil;

/**
 * HTMLの&lt;inut type="image"&gt;タグを生成するタグです。<BR>
 * テキストボックス内に初期表示される値はvalue属性で指定した値です。<BR>
 * name,property属性を指定した場合は、name属性で指定されたオブジェクトの
 * メンバ(property)の値がsrc属性にセットされます<BR>
 * name,property属性を指定しない場合はsrcで指定した値をsrc属性にセットします。<BR>
 *<BR>
 *【属性】<BR>
 * <table cellSpacing=0 cellPadding=0 border=1 >
 * <tr>
 *   <td>property（必須）</td>
 *   <td>
 *   サブミット時に送信されるリクエストパラメータ名です。又、サーブレットからフォワード
 *   されたときにnameで指定されたBeanインスタンスに該当するプロパティがセットされます。<br>
 *   name属性が指定されていない場合はpropertyに指定された値をサーバから取得します。<br>
 *   尚、HTMLのname属性にはpropertyに指定した文字列が出力されます。
 *  （ただしoption、link、imgタグは除く）
 *   </td>
 * <tr>
 * <tr>
 *   <td>name</td>
 *   <td>propertyが属するBeanの名前を指定します。</td>
 * </tr>
 * <tr>
 *   <td>style</td>
 *   <td>このコンポーネントのスタイル</td>
 * </tr>
 * <tr>
 *   <td>scope</td>
 *   <td>propertyのスコープ</td>
 * </tr>
 * <tr>
 *   <td>readonly</td>
 *   <td>このコンポーネントの読取属性（trueの場合は読取専用）</td>
 * </tr>
 * <tr>
 *   <td>disabled</td>
 *   <td>このコンポーネントの使用可否属性（falseの場合は使用不可）</td>
 * </tr>
 * <tr>
 *   <td>csclass</td>
 *   <td>このコンポーネントに指定するスタイルシート</td>
 * </tr>
 * <tr>
 *   <td>
 *   onblur<br>
 *   onchange<br>
 *   onclick<br>
 *   ondblclick<br>
 *   onfocus<br>
 *   onkeydown<br>
 *   onkeypress<br>
 *   onkeyup<br>
 *   onmousedown<br>
 *   onmousemove<br>
 *   onmouseout<br>
 *   onmouseover<br>
 *   onmouseup<br>
 *   </td>
 *   <td>
 *    Javaスクリプト
 *   </td>
 * </tr>
 * <tr>
 *   <td>src</td>
 *   <td>
 *     イメージのパス（Ｗｅｂアプリケーションからの相対パスを指定します）<BR>
 *     name,property属性が指定されていない場合は、srcに指定されたパスからイメージを取得します
 *   </td>
 * </tr>
 * <tr>
 *   <td>title</td>
 *   <td>img属性に表示するタイトル文字列</td>
 * </tr>
 * <tr>
 *   <td>height</td>
 *   <td>イメージの高さ</td>
 * </tr>
 * <tr>
 *   <td>width</td>
 *   <td>
 *     イメージの幅
 *   </td>
 * </tr>
 * <tr>
 *   <td>alt</td>
 *   <td>ボタン用画像の代替テキスト</td>
 * </tr>
 * </table>
 *
 * @author KANO
 * @since jdk1.4.1
 * @version 1.00A 2004/11/1
*/
public class ImageTag extends HtmlTag {
    /** 画像パス */
    protected String src;
    /** テキスト */
    protected String alt;
    /** 幅 */
    protected String width;
    /** 高さ */
    protected String height;
    /** 画像の配置位置 */
    protected String align;
    
    /**
     * @return align を戻します。
     */
    public String getAlign() {
        return align;
    }
    
    /**
     * @param align align を設定。
     */
    public void setAlign(String align) {
        this.align = align;
    }
    
    /**
     * @return height を戻します。
     */
    public String getHeight() {
        return height;
    }
    
    /**
     * @param height height を設定。
     */
    public void setHeight(String height) {
        this.height = height;
    }
    
    /**
     * @return width を戻します。
     */
    public String getWidth() {
        return width;
    }
    
    /**
     * @param width width を設定。
     */
    public void setWidth(String width) {
        this.width = width;
    }
    
    /**
     * 文字列の最大長を取得します
     * @return 文字列の最大長
    */
    public String getSrc() {
        return src;
    }

    /**
     * 文字列の最大長をセットします
     * @param maxlength 文字列の最大長
    */
    public void setSrc(String maxlength) {
        this.src = maxlength;
    }

    /**
     * テキストフィールドのサイズを取得します
     * @return alt テキストフィールドのサイズ
    */
    public String getAlt() {
        return alt;
    }

    /**
     * altをセットします
     * @param alt alt
    */
    public void setAlt(String alt) {
        this.alt = alt;
    }

    /**
     * HTMLの&lt;inut type="image"&gt;タグを生成します<br>
     * scopeが指定されていない場合は、次の順序でオブジェクトを検索します。<br>
     * request, session, contextの順
    */
    public int doStartTag() throws JspException {
        StringBuffer inputTag = new StringBuffer("<input type=\"image\" ");
		if( htmlname != null && htmlname.length() > 0 ){
			inputTag.append( JspTagUtil.createAttribute("name", htmlname) );
		}else{
			inputTag.append( JspTagUtil.createAttribute("name", property) );
		}
		src = JspTagUtil.createRealPath(pageContext, src);
        inputTag.append(JspTagUtil.createAttribute("src", src));
        inputTag.append(JspTagUtil.createAttribute("alt", alt));
        inputTag.append(JspTagUtil.createAttribute("style", style));
		inputTag.append(JspTagUtil.createAttribute("width", width));
		inputTag.append(JspTagUtil.createAttribute("height", height));
		inputTag.append(JspTagUtil.createAttribute("align", align));
		inputTag.append(JspTagUtil.createBoolAttribute("readonly", readonly));
		inputTag.append(JspTagUtil.createBoolAttribute("class", csClass));
        inputTag.append(JspTagUtil.createBoolAttribute("disabled", disabled));
        inputTag.append( JspTagUtil.createAttribute( pageContext, name,
        	property, scope, "value", value));
        inputTag.append(this.createJavaScriptTag());
        inputTag.append(">");

        try {
            pageContext.getOut().print(inputTag.toString());
        } catch (Exception e) {
            throw new JspException(e.getMessage());
        }

        return SKIP_BODY;
    }

    public int doEndTag() {
        return EVAL_PAGE;
    }

}
